/*
 Brad Garton's simple tutorial code for demonstrating neural network learning:
      - as created and demonstrated in Columbia University Computer Music Class of 2001.
      - reproduced with the Author's kind permission.
      
      cc -o interpret interpret.c
*/

#include <stdio.h>
#include "neural.h"
//----------------------------------------------------------------
int main()
{
	struct output out;
	struct hidden hid[NHIDDEN];
	float in[NINPUT];
	int i,j;
	void srrand();
	float rrand();
	float brrand();

/* connect 'em up and randomize the initial weights */
	for (i = 0; i < NHIDDEN; i++) {
		out.hidvals[i] = &(hid+i)->val;
		out.wts[i] = brrand();
		for (j = 0; j < NINPUT; j++) {
			hid[i].invals[j] = in+j;
			hid[i].wts[j] = brrand();
		}
	}

	for(i = 0; i < NINPUT; i++) in[i] = i;
	for (i = 0; i < NHIDDEN; i++) {
		hid[i].val = (i+1)*10;
		for (j = 0; j < NINPUT; j++) {
			printf("hid[%d], invals[%d]: %f   wts[%d]: %f\n",i,j,*(hid[i].invals[j]),j,hid[i].wts[j]);
		}
		printf("out.hidvals[%d]: %f\n",i,*(out.hidvals[i]));
	}

}

//----------------------------------------------------------------
long randx = 1;

void srrand(x)
unsigned x;
{
	randx = x;
}
//----------------------------------------------------------------
float rrand()
{
	int i = ((randx = randx*1103515245 + 12345)>>16) & 077777;
	return((float)i/16384.0 - 1.0);
}
//----------------------------------------------------------------
float brrand()
{
	int i = ((randx = randx*1103515245 + 12345)>>16) & 077777;
	return((float)i/32768.0);
}


